require 'omniauth-oauth2'

module OmniAuth
  module Strategies
    class ProctorU < OmniAuth::Strategies::OAuth2
      option :name, :proctoru
      option :client_options, {
        site: "https://api.proctoru.com",
        authorize_url:  "/oauth/authorize"
      }

      uid { raw_info["uuid"] }

      info do
        prune!({
          :uuid => raw_info["uuid"],
          :email => raw_info["email"],
          :name  => raw_info["first_name"] + raw_info["last_name"],
          :image_url => raw_info["image_url"]
        })
      end

      extra do
        hash = {}
        hash[:raw_info] = raw_info
        prune! hash
      end

      def raw_info
        @raw_info ||= access_token.get('/api/users/me').parsed
      end
    end
  end
end

OmniAuth.config.add_camelization 'proctoru', 'ProctorU'
